## mccode 0.0~git20240608173115.707559c+ds4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0)
cmake_policy(VERSION 3.17.0)

if ( "x${MCVERSION}" STREQUAL "x" )
    set(MCVERSION 3.99.999)
    message(WARNING "Build version was unset. Define using e.g. -DMCVERSION=${MCVERSION}")
endif()

# This file will build McStas and/or McXtrace
project(mccode LANGUAGES C VERSION "${MCVERSION}")
set(CMAKE_C_STANDARD 99)
# Stash the project version for use in C macro comparisons
math(EXPR MCCODE_VERSION_MACRO "(${CMAKE_PROJECT_VERSION_MAJOR} * 100 + ${CMAKE_PROJECT_VERSION_MINOR}) * 1000 + ${CMAKE_PROJECT_VERSION_PATCH}" OUTPUT_FORMAT DECIMAL)

# Set module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

#Ensure various variables are set to sensible default values for the target
#platform (if not already set by a toolchain file):

option( BUILD_MCSTAS "Build McStas" OFF )
option( BUILD_MCXTRACE "Build McXtrace" OFF )
option( BUILD_TOOLS "Include tools" ON )
option( BUILD_MCXRUN "Include mcrun/mxrun even if BUILD_TOOLS is OFF" )#fixme: replace with more fine-grained control
option( ENABLE_COMPONENTS "Whether or not to include comps and instruments" ON )
option( EXCLUDE_CONTRIB "Whether or not to exclude contrib comps" OFF )#fixme: replace with more fine-grained control
option( EXCLUDE_DATA "Whether or not to exclude data files" OFF )#fixme: replace with more fine-grained control

if ( BUILD_MCSTAS AND BUILD_MCXTRACE )
    message(WARNING "Configuration requests building both McStas and McXtrace which is likely to fail.")
elseif( NOT BUILD_MCSTAS AND NOT BUILD_MCXTRACE )
    message(FATAL_ERROR "Configuration requires building one of McStas or McXtrace via -DBUILD_MCXTRACE=ON or -DBUILD_MCSTAS=ON")
endif()

# Setup McCode values (from mkdist or defaults)
include(MCUtil)

if ( BUILD_MCSTAS )
  option( ENSURE_NCRYSTAL "Build Third Party code NCrystal if not already available" ON )
  if ( ENSURE_NCRYSTAL )
    set ( NCRYSTAL_LEGACY_USE 1 )
  else()
    set ( NCRYSTAL_LEGACY_USE 0 )
  endif()
endif()


if( BUILD_MCSTAS )
    setupMCCODE("mcstas")
    message(STATUS "Configuring McStas build ${FLAVOR}")
    add_subdirectory(mcstas)
    if ( ENABLE_COMPONENTS )
      add_subdirectory(mcstas-comps)
    endif()
endif()

if ( BUILD_MCXTRACE )
    setupMCCODE("mcxtrace")
    message(STATUS "Configuring McXtrace build ${FLAVOR}")
    add_subdirectory(mcxtrace)
    if ( ENABLE_COMPONENTS )
      add_subdirectory(mcxtrace-comps)
    endif()
endif()

if ( BUILD_TOOLS )
  add_subdirectory( tools )
elseif ( BUILD_MCXRUN )
  add_subdirectory( tools/Python/mcrun )
  add_subdirectory( tools/Python/mccodelib)
endif()

# Find/Fetch dependencies:

option( ENSURE_MCPL "Build Third Party code MCPL if not already available" ON )
if( ENSURE_MCPL )
  include( MCPL )
endif()

if( BUILD_MCSTAS )
  if ( ENSURE_NCRYSTAL )
    include( NCrystal )
  endif()
endif()

=== mcstas-comps/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17.0 )

# This will install McStas components
project( mcstas-comps C )

# Set module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Set McCode values (from mkdist or defaults)
include(MCUtil)
setupMCCODE("mcstas")

set(WORK "${PROJECT_BINARY_DIR}/work")

# CPack configuration
set(CPACK_PACKAGE_NAME          "${FLAVOR}-comps-${MCCODE_VERSION}")
set(CPACK_RESOURCE_FilE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "1.0")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "0")


# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}-${MCCODE_VERSION}, libnexus-dev")

# NSIS
set(CPACK_NSIS_PACKAGE_NAME "${MCCODE_STRING} Components")
set(CPACK_NSIS_DISPLAY_NAME "${MCCODE_STRING} Components")

include(CPack)

option( ENABLE_CIF2HKL "Build Third Party code cif2hkl (fortran)" ON )#TODO: Only enable enable Fortran if this is on
if ( ENABLE_CIF2HKL )
  enable_language( Fortran )
  add_executable(
    cif2hkl
    ${CMAKE_CURRENT_SOURCE_DIR}/libs/cif2hkl/cif2hkl.F90
    )
  target_compile_options(cif2hkl PUBLIC "-ffree-line-length-512")
  install (
    PROGRAMS "${PROJECT_BINARY_DIR}/cif2hkl${DOT_EXE_SUFFIX}"
    DESTINATION "${DEST_BINDIR}"
    )
endif()

option( ENABLE_NEUTRONICS "Build Third Party code neutronics (fortran)" ON )#TODO: Only enable enable Fortran if this is on
if ( ENABLE_NEUTRONICS )
  enable_language( Fortran )
  add_library(neutronics "STATIC" libs/neutronics/neutronics-subs.f)
  install(TARGETS neutronics DESTINATION "${DEST_LIBDIR}/neutronics")
  #NB (Aug 2023): Removed general "libs" which has the side-effect of not
  #installing other files related to "neutronics".
endif()


file_globsrc( tmp "share/*" )
install( FILES ${tmp} DESTINATION "${DEST_DATADIR_CODEFILES}" )

set( tmp_complist "misc" "monitors" "obsolete" "optics" "samples" "sources" "union" "sasmodels" )
if ( NOT EXCLUDE_CONTRIB )
  list( APPEND tmp_complist "contrib" )
endif()
foreach(name ${tmp_complist})
  file_globsrc( tmp "${name}/*" )
  install( FILES ${tmp} DESTINATION "${DEST_DATADIR_COMPS}/${name}" )
endforeach()

if ( NOT EXCLUDE_CONTRIB )
  foreach(contrib_subdir doc)
    file_globsrc( tmp "contrib/${contrib_subdir}/*" )
    install( FILES ${tmp} DESTINATION "${DEST_DATADIR_COMPS}/contrib/${contrib_subdir}" )
  endforeach()
endif()

if ( NOT EXCLUDE_DATA )
  # base data dir
  file_globsrc( tmp "data/*" )
  install( FILES ${tmp} DESTINATION "${DEST_DATADIR_DATAFILES}" )
  # datadir subfolders
  foreach(data_subdir Gas_tables ISIS_tables)
    file_globsrc( tmp "data/${data_subdir}/*" )
    install( FILES ${tmp} DESTINATION "${DEST_DATADIR_COMPS}/data/${data_subdir}" )
  endforeach()
endif()

install( DIRECTORY "examples/" DESTINATION "${DEST_DATADIR_EXAMPLES}")

file_globsrc( tmp "editors/*" )
install( FILES ${tmp} DESTINATION "${DEST_DATADIR_EDITORS}" )

# Include mcstas-comp revision tag file
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/revision.in" "${WORK}/revision" @ONLY)

# copy some descriptory files
configure_directory ("NOMENCLATURE.md" "work/nomenclature")
configure_directory ("README.md" "work/readme")
install( FILES "${WORK}/nomenclature/NOMENCLATURE.md" DESTINATION "${DEST_DATADIR_COMPS}")
install( FILES "${WORK}/readme/README.md" DESTINATION "${DEST_DATADIR_COMPS}")
install( FILES "${WORK}/revision" DESTINATION "${DEST_DATADIR_COMPS}" )

=== mcstas/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17.0 )

# This file will build McStas
project(mcstas C)
set(CMAKE_C_STANDARD 99)

# Set module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

# Setup McCode values (from mkdist or defaults)
include(MCUtil)
setupMCCODE("mcstas")

# Setup install target
include(InstallMCCODE)
installMCCODE()

=== mcxtrace-comps/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17.0 )

# This will install McXtrace components
project( mcxtrace-comps C )

# Set module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Set McCode values (from mkdist or defaults)
include(MCUtil)
setupMCCODE("mcxtrace")

set(WORK "${PROJECT_BINARY_DIR}/work")

# CPack configuration
set(CPACK_PACKAGE_NAME          "${FLAVOR}-comps-${MCCODE_VERSION}")
set(CPACK_RESOURCE_FilE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "1.0")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "0")


# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}-${MCCODE_VERSION}, libnexus-dev, libxrl-dev")

# NSIS
set(CPACK_NSIS_PACKAGE_NAME "${MCCODE_STRING} Components")
set(CPACK_NSIS_DISPLAY_NAME "${MCCODE_STRING} Components")

include(CPack)

option( ENABLE_CIF2HKL "Build Third Party code cif2hkl (fortran)" ON )#TODO: Only enable enable Fortran if this is on
if ( ENABLE_CIF2HKL )
  enable_language( Fortran )
  add_executable(
    cif2hkl
    ${CMAKE_CURRENT_SOURCE_DIR}/libs/cif2hkl/cif2hkl.F90
    )
  target_compile_options(cif2hkl PUBLIC "-ffree-line-length-512")
  install (
    PROGRAMS "${PROJECT_BINARY_DIR}/cif2hkl${DOT_EXE_SUFFIX}"
    DESTINATION "${DEST_BINDIR}"
    )
endif()



file_globsrc( tmp "share/*" )
install( FILES ${tmp} DESTINATION "${DEST_DATADIR_CODEFILES}" )

set( tmp_complist "misc" "monitors" "obsolete" "optics" "samples" "sources" "union" "sasmodels" "astrox")
if ( NOT EXCLUDE_CONTRIB )
  list( APPEND tmp_complist "contrib" )
endif()
foreach(name ${tmp_complist})
  file_globsrc( tmp "${name}/*" )
  install( FILES ${tmp} DESTINATION "${DEST_DATADIR_COMPS}/${name}" )
endforeach()

# contrib subfolders / examplified from McStas
#if ( NOT EXCLUDE_CONTRIB )
#  foreach(contrib_subdir doc)
#    file_globsrc( tmp "contrib/${contrib_subdir}/*" )
#    install( FILES ${tmp} DESTINATION "${DEST_DATADIR_COMPS}/contrib/${contrib_subdir}" )
#  endforeach()
#endif()

if ( NOT EXCLUDE_DATA )
  # base data dir
  file_globsrc( tmp "data/*" )
  install( FILES ${tmp} DESTINATION "${DEST_DATADIR_DATAFILES}" )
  # datadir subfolders / examplified from McStas
  # foreach(data_subdir Gas_tables ISIS_tables)
  #  file_globsrc( tmp "data/${data_subdir}/*" )
  #  install( FILES ${tmp} DESTINATION "${DEST_DATADIR_COMPS}/data/${data_subdir}" )
  # endforeach()
endif()

install( DIRECTORY "examples/" DESTINATION "${DEST_DATADIR_EXAMPLES}")

file_globsrc( tmp "editors/*" )
install( FILES ${tmp} DESTINATION "${DEST_DATADIR_EDITORS}" )

# Include mcstas-comp revision tag file
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/revision.in" "${WORK}/revision" @ONLY)

# copy some descriptory files
configure_directory ("NOMENCLATURE" "work/nomenclature")
configure_directory ("README.md" "work/readme")
install( FILES "${WORK}/nomenclature/NOMENCLATURE" DESTINATION "${DEST_DATADIR_COMPS}")
install( FILES "${WORK}/readme/README.md" DESTINATION "${DEST_DATADIR_COMPS}")
install( FILES "${WORK}/revision" DESTINATION "${DEST_DATADIR_COMPS}" )

=== mcxtrace/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17.0 )

## This file will build McXtrace
project(mcxtrace C)
set(CMAKE_C_STANDARD 99)

# Set module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

# Setup McCode values (from mkdist or defaults)
include(MCUtil)
setupMCCODE("mcxtrace")

# Setup install target
include(InstallMCCODE)
installMCCODE()

=== tools/cluster-scripts/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17.0 )

# This will install McStas or McXtrace mc/mxrun
project(perl-cluster-tools C)

# Choose between McStas or McXtrace
option(BUILD_MCSTAS   "Choose the McStas flavor" off)
option(BUILD_MCXTRACE "Choose the McXtrace flavor (trumps BUILD_MCSTAS)" Off)

# Set module path
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Set McCode values (from mkdist or defaults)
include(MCUtil)

if (${BUILD_MCXTRACE})
  set(FLAVOR "mcxtrace")
elseif(${BUILD_MCSTAS})
  set(FLAVOR "mcstas")
else()
  message(FATAL_ERROR "No flavor specified!\n"
    "Please use either -DBUILD_MCSTAS=1 or -DBUILD_MCXTRACE=1")
endif()

message("Enabling ${FLAVOR} flavor")
setupMCCODE("${FLAVOR}")

# Select prefix
set(P "${MCCODE_PREFIX}")

# CPack configuration
set(CPACK_PACKAGE_NAME          "${FLAVOR}-clustertools-${MCCODE_VERSION}")
set(CPACK_RESOURCE_FilE_LICENSE "${PROJECT_SOURCE_DIR}/../../COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "${MCCODE_VERSION}")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "0")


# NSIS
set(NSIS_NAME "Cluster scripting tools (slurm, pbs), ${MCCODE_STRING}")
set(CPACK_NSIS_PACKAGE_NAME "${NSIS_NAME}")
set(CPACK_NSIS_DISPLAY_NAME "${NSIS_NAME}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "${NSIS_NAME}")

# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}-${MCCODE_VERSION}, perl, libfile-which-perl")

# RPM
set(CPACK_RPM_PACKAGE_REQUIRES
  "${FLAVOR}-${MCCODE_VERSION}, perl"
  )


include(CPack)

set(WORK "${PROJECT_BINARY_DIR}/work")

# Configure scripts
configure_file("${CMAKE_SOURCE_DIR}/mcsub_pbs.in" "${WORK}/${FLAVOR}_mcsub_pbs" @ONLY)
configure_file("${CMAKE_SOURCE_DIR}/mcsub_slurm.in" "${WORK}/${FLAVOR}_mcsub_slurm" @ONLY)

if(WINDOWS)
  foreach(NAME "mcsub_pbs" "mcsub_slurm")
    install(
      FILES "${WORK}/${NAME}"
      DESTINATION "${bin}/${NAME}.pl"
      )
  endforeach()
else()
  foreach(NAME "${FLAVOR}_mcsub_pbs" "${FLAVOR}_mcsub_slurm")
    install(
      FILES "${WORK}/${NAME}"
      DESTINATION "${FLAVOR}/${MCCODE_VERSION}/bin"
      )
  endforeach()
endif()

=== docpkg/manuals/mcstas/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17.0 )

# This will install McStas components
set(FLAVOR mcstas)
project(${FLAVOR}_manuals C)

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_SOURCE_DIR}/cmake/Modules/")

message( "CMAKE_SOURCE_DIR=        ${CMAKE_SOURCE_DIR}" )
message( "CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}" )
message( "CMAKE_CURRENT_LIST_DIR=  ${CMAKE_CURRENT_LIST_DIR}" )
message( "PROJECT_SOURCE_DIR=      ${PROJECT_SOURCE_DIR}" )
message( "PROJECT_BINARY_DIR=      ${PROJECT_BINARY_DIR}" )

message( "include MCUtil" )
include(MCUtil)
message( "setup MCCODE" )
setupMCCODE("${FLAVOR}")

# CPack configuration
message( "CPack configuration" )
set(CPACK_PACKAGE_NAME          "${FLAVOR}-manuals-${MCCODE_VERSION}")
set(CPACK_RESOURCE_FilE_LICENSE "${PROJECT_SOURCE_DIR}/../COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "1.0")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "0")

# NSIS
set(NSIS_NAME "Manuals, ${MCCODE_VERSION}")
set(CPACK_NSIS_PACKAGE_NAME "${NSIS_NAME}")
set(CPACK_NSIS_DISPLAY_NAME "${NSIS_NAME}")

set(MANUAL "${FLAVOR}-manual.pdf")
set(CMANUAL "${FLAVOR}-components.pdf")

set(MCCODE_LIB "${DEST_DATADIR_COMPS}")
set(MANDEST "${DEST_DATADIR_DOC}")

# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}-${MCCODE_VERSION}")

include(CPack)

install(FILES "${PROJECT_SOURCE_DIR}/manual.pdf"
  DESTINATION "${MANDEST}"
  RENAME "${MANUAL}"
)

install(FILES "${PROJECT_SOURCE_DIR}/Component_manual.pdf"
  DESTINATION "${MANDEST}"
  RENAME "${CMANUAL}"
)

=== docpkg/manuals/mcxtrace/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.17.0 )

# This will install McStas components
set(FLAVOR mcxtrace)
project(${FLAVOR}_manuals C)

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_SOURCE_DIR}/cmake/Modules/")

message( "CMAKE_SOURCE_DIR=        ${CMAKE_SOURCE_DIR}" )
message( "CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}" )
message( "CMAKE_CURRENT_LIST_DIR=  ${CMAKE_CURRENT_LIST_DIR}" )
message( "PROJECT_SOURCE_DIR=      ${PROJECT_SOURCE_DIR}" )
message( "PROJECT_BINARY_DIR=      ${PROJECT_BINARY_DIR}" )

message( "include MCUtil" )
include(MCUtil)
message( "setup MCCODE" )
setupMCCODE("${FLAVOR}")

# CPack configuration
message( "CPack configuration" )
set(CPACK_PACKAGE_NAME          "${FLAVOR}-manuals-${MCCODE_VERSION}")
set(CPACK_RESOURCE_FilE_LICENSE "${PROJECT_SOURCE_DIR}/../COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "1.0")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "0")

# NSIS
set(NSIS_NAME "Manuals, ${MCCODE_VERSION}")
set(CPACK_NSIS_PACKAGE_NAME "${NSIS_NAME}")
set(CPACK_NSIS_DISPLAY_NAME "${NSIS_NAME}")

set(MANUAL "${FLAVOR}-manual.pdf")
set(CMANUAL "${FLAVOR}-components.pdf")

set(MCCODE_LIB "${DEST_DATADIR_COMPS}")
set(MANDEST "${DEST_DATADIR_DOC}")

# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}-${MCCODE_VERSION}")

include(CPack)

install(FILES "${PROJECT_SOURCE_DIR}/manual.pdf"
  DESTINATION "${MANDEST}"
  RENAME "${MANUAL}"
)

install(FILES "${PROJECT_SOURCE_DIR}/Component_manual.pdf"
  DESTINATION "${MANDEST}"
  RENAME "${CMANUAL}"
)

=== tools/Python/mccodelib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0)
cmake_policy(VERSION 3.17.0)

# This will install McStas components
project(python-tools-mccodelib C)

message(STATUS "Configure ${CMAKE_PROJECT_NAME} ${FLAVOR} ${PROJECT_NAME}")

# Choose between McStas or McXtrace
option(BUILD_MCSTAS   "Choose the McStas flavor" off)
option(BUILD_MCXTRACE "Choose the McXtrace flavor (trumps BUILD_MCSTAS)" Off)


#Option normally needed only for the conda pkg recipe:
option(MCCODE_BUILD_CONDA_PKG   "If current build will be relocatable conda package" OFF)

# Set module path
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

# Set McCode values (from mkdist or defaults)
include(MCUtil)

if (${BUILD_MCXTRACE})
  set(FLAVOR "mcxtrace")
elseif(${BUILD_MCSTAS})
  set(FLAVOR "mcstas")
else()
  message(FATAL_ERROR "No flavor specified!\n"
    "Please use either -DBUILD_MCSTAS=1 or -DBUILD_MCXTRACE=1")
endif()

setupMCCODE("${FLAVOR}")

# Select prefix
if(${BUILD_MCSTAS})
  set(P "mc")
else()
  set(P "mx")
endif()

set(TOOLS_NAME "Python/mccodelib")

set(TOOLS_LIB "${DEST_TOOLDIR}/${TOOLS_NAME}")
set(MCCODE_LOCATION "${DEST_TOOLDIR}")


# Set some extra options for mccode_config
set(CC "${CMAKE_C_COMPILER}")
if (APPLE)
  set(CFLAGS "-headerpad_max_install_names ${CMAKE_C_FLAGS} ${MCCODE_CFLAGS}")
else()
  set(CFLAGS "${CMAKE_C_FLAGS} ${MCCODE_CFLAGS}")
endif()

# CPack configuration
set(CPACK_PACKAGE_NAME          "${FLAVOR}-tools-python-mccodelib-${MCCODE_VERSION}")
set(CPACK_RESOURCE_FilE_LICENSE "${PROJECT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_CONTACT       "jsbn@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "${MCCODE_VERSION}")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "0")


# NSIS
set(NSIS_NAME "Python internal library, ${MCCODE_STRING}")
set(CPACK_NSIS_PACKAGE_NAME "${NSIS_NAME}")
set(CPACK_NSIS_DISPLAY_NAME "${NSIS_NAME}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "${NSIS_NAME}")

# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}-${MCCODE_VERSION}, python3, python3-ply, hdf-compass")

# RPM
if (RPMPROFILE)
  if (RPMPROFILE STREQUAL "fedora")
    set(PYDEPS "python3, python3-ply")
  else()
    set(PYDEPS ${FLAVOR}-miniconda3-${MCCODE_VERSION})
  endif()
else()
  set(PYDEPS ${FLAVOR}-miniconda3-${MCCODE_VERSION})
endif()

set(CPACK_RPM_PACKAGE_REQUIRES
  "${FLAVOR}-${MCCODE_VERSION}, ${PYDEPS}"
)

include(CPack)

set(WORK "${PROJECT_BINARY_DIR}/work")

set(entries_with_conda_prefix "CFLAGS;NEXUSFLAGS;MPIFLAGS;GSLFLAGS;XRLFLAGS;OACCFLAGS;TOOLS_CC;MPIRUN;MPICC")
foreach( var ${entries_with_conda_prefix} )
  set( MCCODE_FINAL_${var} "${${var}}" )
endforeach()

if ( MCCODE_BUILD_CONDA_PKG )
  #Conda pkgs mode need special treatment, to make sure compiler name is not an
  #absolute path into the build conda env:
  set( MCCODE_IS_CONDA_PKG "1" )
  set( conda_prefix "$ENV{CONDA_PREFIX}" )
  if(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    set( isysroot "$ENV{CONDA_BUILD_SYSROOT}" )
  endif()
  foreach( var ${entries_with_conda_prefix} )
    message("Investigating variable ${var}")
    if(NOT "${conda_prefix}" STREQUAL "")
      string(REPLACE "${conda_prefix}" "\$\{CONDA_PREFIX\}" MCCODE_FINAL_${var} "${MCCODE_FINAL_${var}}")
      if(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	message(STATUS "Change:\n --> -isysroot ${isysroot} -> -isysroot \$\{XCRUN_DETECTED\} if present in MCCODE_FINAL_${var}")
	string(REPLACE "${isysroot}" "\$\{XCRUN_DETECTED\}" MCCODE_FINAL_${var} "${MCCODE_FINAL_${var}}")
      endif()
    endif()
    message(STATUS "-> MCCODE_FINAL_${var}=${MCCODE_FINAL_${var}}")
  endforeach()
  #get_filename_component(MCCODE_FINAL_TOOLS_CC "${MCCODE_FINAL_TOOLS_CC}" NAME)
else()
  set( MCCODE_IS_CONDA_PKG "0" )
endif()

# HDF-viewer
if ( MCCODE_BUILD_CONDA_PKG )
  set( HDFVIEW "nexpy" )
else ()
  set( HDFVIEW "HDFCompass" )
endif ()

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/mccode_config.py.in" "${WORK}/mccode_config.py" @ONLY)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/mccode_config.json.in" "${WORK}/mccode_config.json" @ONLY)

# Python files
foreach(name __init__.py fcparticleparser.py utils.py flowchart.py instrgeom.py instrparser.py mcdisplayutils.py mcplotloader.py nodetree.py particleparser.py pipetools.py plotgraph.py pqtgfrontend.py cflags.py)
  install(
    FILES "${PROJECT_SOURCE_DIR}/${name}"
    DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
    )
endforeach()

install(
  FILES "${WORK}/mccode_config.py" "${WORK}/mccode_config.json"
  DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
  )

=== tools/Python/mcdisplay/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0)
cmake_policy(VERSION 3.17.0)

add_subdirectory(mantid_xml)
add_subdirectory(matplotlib)
add_subdirectory(pyqtgraph)
add_subdirectory(webgl)
add_subdirectory(cad)

=== tools/Python/mcdoc/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0)
cmake_policy(VERSION 3.17.0)

# This will install McStas or McXtrace mc/mxdoc
project(python-tools-mcdoc C)

message(STATUS "Configure ${CMAKE_PROJECT_NAME} ${FLAVOR} ${PROJECT_NAME}")

# Choose between McStas or McXtrace
option(BUILD_MCSTAS   "Choose the McStas flavor" off)
option(BUILD_MCXTRACE "Choose the McXtrace flavor (trumps BUILD_MCSTAS)" Off)

# Set module path
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

# Set McCode values (from mkdist or defaults)
include(MCUtil)

if (${BUILD_MCXTRACE})
  set(FLAVOR "mcxtrace")
  set(CPACK_PACKAGE_HOMEPAGE_URL "http://mcxtrace.org/")
elseif(${BUILD_MCSTAS})
  set(FLAVOR "mcstas")
  set(CPACK_PACKAGE_HOMEPAGE_URL "http://mcstas.org/")
else()
  message(FATAL_ERROR "No flavor specified!\n"
    "Please use either -DBUILD_MCSTAS=1 or -DBUILD_MCXTRACE=1")
endif()

setupMCCODE("${FLAVOR}")

# Select prefix
set(P "${MCCODE_PREFIX}")

set(TOOLS_NAME "Python/${P}doc/")

# CPack configuration
set(CPACK_PACKAGE_NAME          "${FLAVOR}-tools-python-${P}doc-${MCCODE_VERSION}")
set(CPACK_RESOURCE_FilE_LICENSE "${PROJECT_SOURCE_DIR}/../../COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "${MCCODE_VERSION}")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "0")


# NSIS
set(NSIS_NAME "Python-based mcdoc, ${MCCODE_STRING}")
set(CPACK_NSIS_PACKAGE_NAME "${NSIS_NAME}")
set(CPACK_NSIS_DISPLAY_NAME "${NSIS_NAME}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "${NSIS_NAME}")

# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}-${MCCODE_VERSION}, ${FLAVOR}-comps-${MCCODE_VERSION}")

# RPM
if (RPMPROFILE)
   if (RPMPROFILE STREQUAL "fedora")
        set(PYDEPS "python3")
   else()
	set(PYDEPS "")
   endif()
else()
	set(PYDEPS "")
endif()

set(CPACK_RPM_PACKAGE_REQUIRES
  "${FLAVOR}-${MCCODE_VERSION}, ${PYDEPS}"
)

include(CPack)

set(WORK "${PROJECT_BINARY_DIR}/work")

# Configure fallback script
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/mcdoc.in" "${WORK}/${P}doc" @ONLY)

# Main script, including rename mcdoc/mxdoc
install(
  FILES "${PROJECT_SOURCE_DIR}/mcdoc.py"
  DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
  RENAME "${P}doc.py"
  PERMISSIONS
  OWNER_READ OWNER_WRITE OWNER_EXECUTE
  GROUP_READ GROUP_EXECUTE
  WORLD_READ WORLD_EXECUTE
  )

# Wrapper-scripts on windows are handled via
# cmake Modules/MCUtil
if(NOT WINDOWS)
  add_custom_target(
    "CREATE_${PROJECT_NAME}_SYMLINK" ALL DEPENDS "${WORK}/${P}doc"
    )

  install(
    FILES "${WORK}/${P}doc"
    DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
    PERMISSIONS
    OWNER_READ OWNER_WRITE OWNER_EXECUTE
    GROUP_READ GROUP_EXECUTE
    WORLD_READ WORLD_EXECUTE
  )
  install(
    PROGRAMS "${WORK}/${P}doc"
    DESTINATION ${DEST_BINDIR}
    )

endif()

=== tools/Python/mcgui/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0)
cmake_policy(VERSION 3.17.0)

# This will install McStas or McXtrace mc/mxgui
project(python-tools-mcgui C)

message(STATUS "Configure ${CMAKE_PROJECT_NAME} ${FLAVOR} ${PROJECT_NAME}")

# Choose between McStas or McXtrace
option(BUILD_MCSTAS   "Choose the McStas flavor" off)
option(BUILD_MCXTRACE "Choose the McXtrace flavor (trumps BUILD_MCSTAS)" Off)

# Set module path
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

# Set McCode values (from mkdist or defaults)
include(MCUtil)

if (${BUILD_MCXTRACE})
  set(FLAVOR "mcxtrace")
  set(CPACK_PACKAGE_HOMEPAGE_URL "http://mcxtrace.org/")
elseif(${BUILD_MCSTAS})
  set(FLAVOR "mcstas")
  set(CPACK_PACKAGE_HOMEPAGE_URL "http://mcstas.org/")
else()
  message(FATAL_ERROR "No flavor specified!\n"
    "Please use either -DBUILD_MCSTAS=1 or -DBUILD_MCXTRACE=1")
endif()

setupMCCODE("${FLAVOR}")

# Select prefix
set(P "${MCCODE_PREFIX}")

set(TOOLS_NAME "Python/${P}gui/")

# CPack configuration
set(CPACK_PACKAGE_NAME          "${FLAVOR}-tools-python-${P}gui-${MCCODE_VERSION}")
set(CPACK_RESOURCE_FilE_LICENSE "${PROJECT_SOURCE_DIR}/../../COPYING")
set(CPACK_PACKAGE_CONTACT       "pkwi@fysik.dtu.dk")

set(CPACK_PACKAGE_VERSION       "${MCCODE_VERSION}")
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "0")


# NSIS
set(NSIS_NAME "Python-based mcgui (mcgui-py), ${MCCODE_STRING}")
set(CPACK_NSIS_PACKAGE_NAME "${NSIS_NAME}")
set(CPACK_NSIS_DISPLAY_NAME "${NSIS_NAME}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "${NSIS_NAME}")

# Debian
set(CPACK_DEBIAN_PACKAGE_DEPENDS "${FLAVOR}-${MCCODE_VERSION}, ${FLAVOR}-tools-python-${P}doc-${MCCODE_VERSION}, ${FLAVOR}-tools-python-mccodelib-${MCCODE_VERSION}, python3, python3-pyqt5.qsci")

# RPM
if (RPMPROFILE)
   if (RPMPROFILE STREQUAL "fedora")
        set(PYDEPS "python3, python3-qt5, python3-qscintilla-qt5")
   else()
	set(PYDEPS "")
   endif()
else()
	set(PYDEPS "")
endif()

set(CPACK_RPM_PACKAGE_REQUIRES
  "${FLAVOR}-${MCCODE_VERSION}, ${FLAVOR}-tools-python-${P}doc-${MCCODE_VERSION}, ${FLAVOR}-tools-python-mccodelib-${MCCODE_VERSION}, qt5-qtbase-gui")

include(CPack)

set(WORK "${PROJECT_BINARY_DIR}/work")

# Configure fallback script
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/mcgui.in" "${WORK}/${P}gui" @ONLY)

# Configure launcher
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/McCode-py.desktop.in" "work/${FLAVOR}-${MCCODE_VERSION}-py.desktop")

# Main script, including rename mcgui/mxgui
install(
  PROGRAMS "${PROJECT_SOURCE_DIR}/mcgui.py"
  DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
  RENAME "${P}gui.py"
  )

# Other .py infrastructure
foreach(NAME viewclasses.py run-icon.png compile-icon.png widgets.py ${FLAVOR}-py.png)
  install(
    FILES "${PROJECT_SOURCE_DIR}/${NAME}"
    DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
    )
endforeach()

# Wrapper-scripts on windows are handled via
# cmake Modules/MCUtil
if(NOT WINDOWS)
  add_custom_target(
    "CREATE_${PROJECT_NAME}_SYMLINK" ALL DEPENDS "${WORK}/${P}gui"
    )

  install(
    FILES "${WORK}/${P}gui"
    DESTINATION "${DEST_TOOLDIR}/${TOOLS_NAME}"
    PERMISSIONS
    OWNER_READ OWNER_WRITE OWNER_EXECUTE
    GROUP_READ GROUP_EXECUTE
    WORLD_READ WORLD_EXECUTE
  )
  install(
    PROGRAMS "${WORK}/${P}gui"
    DESTINATION ${DEST_BINDIR}
    )


endif()

## mccode 0.0~git20240605070528.f22fe13+ds4

=== debian/changelog ===
mccode (0.0~git20240605070528.f22fe13+ds4-1) unstable; urgency=medium

  * New upstream snapshot.
  * Packaging fixes all around.

 -- Roland Mas <lolando@debian.org>  Wed, 05 Jun 2024 13:26:06 +0200

mccode (0.0~git20240131101836.f06506e+ds4-1) unstable; urgency=medium

  * New upstream snapshot.
  * Filter out deprecated (and GPL-2) Perl stuff.
  * Add a custom debian/update-copyright.pl script to generate
    proposed debian/copyright info from *.comp and *.instr.
  * Run this script on the very many *.comp and *.instr instrument
    description files that were added recently upstream. This should
    bring debian/copyright to completeness.

 -- Roland Mas <lolando@debian.org>  Tue, 06 Feb 2024 14:28:39 +0100

mccode (0.0~git20231013163107.09cdb09+ds3-1) UNRELEASED; urgency=medium

  * New upstream snapshot, wholly GPL3 now (apart from a language
    specification for GtkSourceView).

 -- Roland Mas <lolando@debian.org>  Wed, 18 Oct 2023 19:54:41 +0200

mccode (0.0~git20230407082717.9acc187+ds3-2) UNRELEASED; urgency=medium

  * Drop empty mccode-common package.

 -- Roland Mas <lolando@debian.org>  Wed, 12 Apr 2023 23:42:24 +0200

mccode (0.0~git20230407082717.9acc187+ds3-1) UNRELEASED; urgency=medium

  * New upstream snapshot.
  * Remove cif2hkl from source package.
  * Depend on external cif2hkl package.

 -- Roland Mas <lolando@debian.org>  Wed, 12 Apr 2023 16:48:05 +0200

mccode (0.0~git20230208073439.37d725b+ds3-3) UNRELEASED; urgency=medium

  * New upstream snapshot, with licensing updates.

 -- Roland Mas <lolando@debian.org>  Wed, 08 Feb 2023 17:34:19 +0100

mccode (0.0~git20221219130132.5c190e2+ds3-2) UNRELEASED; urgency=medium

  * Use execute_{before,after}_* targets instead of override_* in
    debian/rules when relevant.
  * Update debian/copyright.

 -- Roland Mas <lolando@debian.org>  Thu, 26 Jan 2023 18:24:08 +0100

mccode (0.0~git20221219130132.5c190e2+ds3-1) UNRELEASED; urgency=medium

  * New upstream snapshot.
  * Upstream switched to GPLv3.
  * Initial release (Closes: #997901, 997903).

 -- Roland Mas <lolando@debian.org>  Wed, 04 Jan 2023 10:48:26 +0100

mccode (0.0~git20211202102942.9ba178d+ds1-1) UNRELEASED; urgency=medium

  * New upstream snapshot.

 -- Roland Mas <lolando@debian.org>  Fri, 03 Dec 2021 19:11:28 +0100

mccode (0.0~git20211124103033.5cdca6f+ds1-1) UNRELEASED; urgency=medium

  * New upstream snapshot.

 -- Roland Mas <lolando@debian.org>  Mon, 29 Nov 2021 16:31:25 +0100

mccode (0.0~git20211113150921.18627c7+ds1-1) UNRELEASED; urgency=medium

  * New upstream snapshot.

 -- Roland Mas <lolando@debian.org>  Mon, 15 Nov 2021 18:15:58 +0100

mccode (0.0~git20211105125748.a3ac847+ds3-1) UNRELEASED; urgency=medium

  * New upstream snapshot.

 -- Roland Mas <lolando@debian.org>  Sat, 06 Nov 2021 14:37:39 +0100

mccode (0.0~git20211028093520.f1de7df+ds2-1) UNRELEASED; urgency=medium

  * Start work on packaging McStas/McXtrace (collectively, McCode).

 -- Roland Mas <lolando@debian.org>  Sun, 31 Oct 2021 15:36:03 +0100

=== debian/control ===
Source: mccode
Section: science
Priority: optional
Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders: Roland Mas <lolando@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, dh-cmake, bison, flex,
 gfortran, recode, python3-all
Standards-Version: 4.5.1
Homepage: https://github.com/McStasMcXtrace/McCode
Vcs-Browser: https://salsa.debian.org/science-team/mccode
Vcs-Git: https://salsa.debian.org/science-team/mccode.git
Rules-Requires-Root: no

Package: mcstas
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, mccode-common
Description: Neutron ray-trace simulation
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the McStas engine itself.

Package: mcstas-comps
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, mcpl, libmcpl-dev, cif2hkl
Description: Neutron ray-trace simulation - components
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the McStas components (i.e. models for
 simulated instruments and objects).

Package: mcstas-clusterscripts
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Neutron ray-trace simulation - parallelization scripts
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains scripts to run McStas in parallel on various
 types of clusters.

Package: mcstas-manuals
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Neutron ray-trace simulation - documentation
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the documentation.

# Package: mcstas-tools-matlab-mcplot
# Architecture: any
# Depends: ${shlibs:Depends}, ${misc:Depends}
# Description: Neutron ray-trace simulation - Matlab plotting frontend
#  McStas is a tool for carrying out Monte Carlo ray-tracing simulations
#  of neutron scattering instruments with high complexity and
#  precision. The simulations can compute all aspects of the performance
#  of instruments and can thus be used to optimize the use of existing
#  equipment, design new instrumentation, and carry out virtual
#  experiments for e.g. training, experimental planning or data
#  analysis.
#  .
#  McStas is based on a unique design where an automatic compilation
#  process translates high-level textual instrument descriptions into
#  efficient ISO-C code.
#  .
#  This package contains a Matlab frontend for the simulation result viewer.

Package: mcstas-mccodelib
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3
Description: Neutron ray-trace simulation - Python code library
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains Python libraries.

Package: mcstas-mcdisplay-mantid
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3
Description: Neutron ray-trace simulation - Mantid instrument display
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the Mantid frontend for the McStas instrument
 display.

Package: mcstas-mcdisplay-pyqtgraph
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-pyqtgraph
Description: Neutron ray-trace simulation - pyqtgraph instrument display
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the pyqtgraph frontend for the instrument
 display.

Package: mcstas-mcdisplay-webgl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3, libjs-three
Description: Neutron ray-trace simulation - WebGL instrument display
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the WebGL frontend for the instrument
 display.

Package: mcstas-mcdoc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3
Description: Neutron ray-trace simulation - documentation browser
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains mcdoc, a tool to display documentation for
 McStas itself and for the simulated instruments.

Package: mcstas-mcgui
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-pyqt5, mcstas-mcrun
Description: Neutron ray-trace simulation - GUI
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the graphical user interface.

Package: mcstas-mcplot-matplotlib
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-matplotlib
Description: Neutron ray-trace simulation - Matplotlib plotting frontend
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the Matplotlib plotting frontend for the
 simulation results.

Package: mcstas-mcplot-pyqtgraph
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-pyqtgraph
Description: Neutron ray-trace simulation - pyqtgraph plotting frontend
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the pyqtgraph plotting frontend for the
 simulation results.

Package: mcstas-mcplot-svg
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3, libjs-d3
Description: Neutron ray-trace simulation - SVG plotting frontend
 McStas is a tool for carrying out Monte Carlo ray-tracing simulations
 of neutron scattering instruments with high complexity and
 precision. The simulations can compute all aspects of the performance
 of instruments and can thus be used to optimize the use of existing
 equipment, design new instrumentation, and carry out virtual
 experiments for e.g. training, experimental planning or data
 analysis.
 .
 McStas is based on a unique design where an automatic compilation
 process translates high-level textual instrument descriptions into
 efficient ISO-C code.
 .
 This package contains the SVG plotting frontend for the
 simulation results.

Package: mcstas-mcresplot
Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

INSTALL_PREFIX=/usr/share/mccode
MCCODE_VERSION=3
MCSTAS_VERSION=3.2
MCXTRACE_VERSION=3.1

CMAKE_ARGS=-DCMAKE_INSTALL_PREFIX=$(INSTALL_PREFIX) -DMCCODE_VERSION=$(MCCODE_VERSION) -DMCCODE_USE_LEGACY_DESTINATIONS=OFF -DENABLE_CIF2HKL=OFF
CMAKE_ARGS_N=-Denable_mcstas=1 -DBUILD_MCSTAS=1 $(CMAKE_ARGS)
CMAKE_ARGS_X=-Denable_mcxtrace=1 -DBUILD_MCXTRACE=1 $(CMAKE_ARGS)

PARALLEL=$(shell echo $DEB_BUILD_OPTIONS|xargs -n 1|grep ^parallel=|cut -d= -f2)
ifneq ($(strip $(PARALLEL)),)
	MAKE_ARGS=-j$(PARALLEL)
endif

%:
	dh $@ --with cmake

execute_after_dh_auto_clean:
	rm -f cmake/Modules/debian.cmake

override_dh_auto_configure:

override_dh_auto_build:
	mkdir -p BUILD
	cp cmake/toolchains/deb64.cmake cmake/Modules/debian.cmake
	sed -i -e /amd64/d -e/CMAKE_SYSTEM_NAME/d cmake/Modules/debian.cmake

	mkdir -p BUILD/mcstas
	cd BUILD/mcstas && cmake $(CMAKE_ARGS_N) $(CURDIR)/mcstas && make $(MAKE_ARGS)

	mkdir -p BUILD/mcstas-comps
	cd BUILD/mcstas-comps && cmake $(CMAKE_ARGS_N) $(CURDIR)/mcstas-comps && make $(MAKE_ARGS)

	mkdir -p BUILD/mcstas-mccodelib
	cd BUILD/mcstas-mccodelib && cmake $(CMAKE_ARGS_N) $(CURDIR)/tools/Python/mccodelib/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcstas-mcplot-pyqtgraph
	cd BUILD/mcstas-mcplot-pyqtgraph && cmake $(CMAKE_ARGS_N) $(CURDIR)/tools/Python/mcplot/pyqtgraph/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcstas-mcplot-matplotlib
	cd BUILD/mcstas-mcplot-matplotlib && cmake $(CMAKE_ARGS_N) $(CURDIR)/tools/Python/mcplot/matplotlib/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcstas-mcplot-svg
	cd BUILD/mcstas-mcplot-svg && cmake $(CMAKE_ARGS_N) $(CURDIR)/tools/Python/mcplot/svg/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcstas-mcresplot
	cd BUILD/mcstas-mcresplot && cmake $(CMAKE_ARGS_N) $(CURDIR)/tools/Python/mcresplot/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcstas-mcrun
	cd BUILD/mcstas-mcrun && cmake $(CMAKE_ARGS_N) $(CURDIR)/tools/Python/mcrun/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcstas-mcgui
	cd BUILD/mcstas-mcgui && cmake $(CMAKE_ARGS_N) $(CURDIR)/tools/Python/mcgui/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcstas-mcdisplay-webgl
	cd BUILD/mcstas-mcdisplay-webgl && cmake $(CMAKE_ARGS_N) $(CURDIR)/tools/Python/mcdisplay/webgl/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcstas-mcdisplay-pyqtgraph
	cd BUILD/mcstas-mcdisplay-pyqtgraph && cmake $(CMAKE_ARGS_N) $(CURDIR)/tools/Python/mcdisplay/pyqtgraph/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcstas-mcdisplay-mantid
	cd BUILD/mcstas-mcdisplay-mantid && cmake $(CMAKE_ARGS_N) $(CURDIR)/tools/Python/mcdisplay/mantid_xml/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcstas-clusterscripts
	cd BUILD/mcstas-clusterscripts && cmake $(CMAKE_ARGS_N) $(CURDIR)/tools/cluster-scripts/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcstas-manuals
	cd BUILD/mcstas-manuals && cmake $(CMAKE_ARGS_N) $(CURDIR)/docpkg/manuals/mcstas/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcstas-mcdoc
	cd BUILD/mcstas-mcdoc && cmake $(CMAKE_ARGS_N) $(CURDIR)/tools/Python/mcdoc/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcxtrace
	cd BUILD/mcxtrace && cmake $(CMAKE_ARGS_X) $(CURDIR)/mcxtrace && make $(MAKE_ARGS)

	mkdir -p BUILD/mcxtrace-comps
	cd BUILD/mcxtrace-comps && cmake $(CMAKE_ARGS_X) $(CURDIR)/mcxtrace-comps && make $(MAKE_ARGS)

	mkdir -p BUILD/mcxtrace-mccodelib
	cd BUILD/mcxtrace-mccodelib && cmake $(CMAKE_ARGS_X) $(CURDIR)/tools/Python/mccodelib/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcxtrace-mxplot-matplotlib
	cd BUILD/mcxtrace-mxplot-matplotlib && cmake $(CMAKE_ARGS_X) $(CURDIR)/tools/Python/mcplot/matplotlib/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcxtrace-mxplot-pyqtgraph
	cd BUILD/mcxtrace-mxplot-pyqtgraph && cmake $(CMAKE_ARGS_X) $(CURDIR)/tools/Python/mcplot/pyqtgraph/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcxtrace-mxplot-svg
	cd BUILD/mcxtrace-mxplot-svg && cmake $(CMAKE_ARGS_X) $(CURDIR)/tools/Python/mcplot/svg/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcxtrace-mxrun
	cd BUILD/mcxtrace-mxrun && cmake $(CMAKE_ARGS_X) $(CURDIR)/tools/Python/mcrun/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcxtrace-mxgui
	cd BUILD/mcxtrace-mxgui && cmake $(CMAKE_ARGS_X) $(CURDIR)/tools/Python/mcgui/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcxtrace-mxdisplay-webgl
	cd BUILD/mcxtrace-mxdisplay-webgl && cmake $(CMAKE_ARGS_X) $(CURDIR)/tools/Python/mcdisplay/webgl/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcxtrace-mxdisplay-pyqtgraph
	cd BUILD/mcxtrace-mxdisplay-pyqtgraph && cmake $(CMAKE_ARGS_X) $(CURDIR)/tools/Python/mcdisplay/pyqtgraph/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcxtrace-clusterscripts
	cd BUILD/mcxtrace-clusterscripts && cmake $(CMAKE_ARGS_X) $(CURDIR)/tools/cluster-scripts/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcxtrace-manuals
	cd BUILD/mcxtrace-manuals && cmake $(CMAKE_ARGS_X) $(CURDIR)/docpkg/manuals/mcxtrace/ && make $(MAKE_ARGS)

	mkdir -p BUILD/mcxtrace-mxdoc
	cd BUILD/mcxtrace-mxdoc && cmake $(CMAKE_ARGS_X) $(CURDIR)/tools/Python/mcdoc/ && make $(MAKE_ARGS)

execute_before_dh_auto_install:
	cd BUILD/mcstas && make install DESTDIR=$(CURDIR)/debian/mcstas
	cd BUILD/mcstas-comps && make install DESTDIR=$(CURDIR)/debian/mcstas-comps
	cd BUILD/mcstas-mccodelib && make install DESTDIR=$(CURDIR)/debian/mcstas-mccodelib
	cd BUILD/mcstas-mcplot-pyqtgraph && make install DESTDIR=$(CURDIR)/debian/mcstas-mcplot-pyqtgraph
	cd BUILD/mcstas-mcplot-matplotlib && make install DESTDIR=$(CURDIR)/debian/mcstas-mcplot-matplotlib
	cd BUILD/mcstas-mcplot-svg && make install DESTDIR=$(CURDIR)/debian/mcstas-mcplot-svg
	cd BUILD/mcstas-mcresplot && make install DESTDIR=$(CURDIR)/debian/mcstas-mcresplot
	cd BUILD/mcstas-mcrun && make install DESTDIR=$(CURDIR)/debian/mcstas-mcrun
	cd BUILD/mcstas-mcgui && make install DESTDIR=$(CURDIR)/debian/mcstas-mcgui
	cd BUILD/mcstas-mcdisplay-webgl && make install DESTDIR=$(CURDIR)/debian/mcstas-mcdisplay-webgl
	cd BUILD/mcstas-mcdisplay-pyqtgraph && make install DESTDIR=$(CURDIR)/debian/mcstas-mcdisplay-pyqtgraph
	cd BUILD/mcstas-mcdisplay-mantid && make install DESTDIR=$(CURDIR)/debian/mcstas-mcdisplay-mantid
	cd BUILD/mcstas-clusterscripts && make install DESTDIR=$(CURDIR)/debian/mcstas-clusterscripts
	cd BUILD/mcstas-manuals && make install DESTDIR=$(CURDIR)/debian/mcstas-manuals
	cd BUILD/mcstas-mcdoc && make install DESTDIR=$(CURDIR)/debian/mcstas-mcdoc
	# cd BUILD/mcstas-ncrystal && make install DESTDIR=$(CURDIR)/debian/mcstas-ncrystal

	cd BUILD/mcxtrace && make install DESTDIR=$(CURDIR)/debian/mcxtrace
	cd BUILD/mcxtrace-comps && make install DESTDIR=$(CURDIR)/debian/mcxtrace-comps
	cd BUILD/mcxtrace-mccodelib && make install DESTDIR=$(CURDIR)/debian/mcxtrace-mccodelib
	cd BUILD/mcxtrace-mxplot-matplotlib && make install DESTDIR=$(CURDIR)/debian/mcxtrace-mxplot-matplotlib
	cd BUILD/mcxtrace-mxplot-pyqtgraph && make install DESTDIR=$(CURDIR)/debian/mcxtrace-mxplot-pyqtgraph
	cd BUILD/mcxtrace-mxplot-svg && make install DESTDIR=$(CURDIR)/debian/mcxtrace-mxplot-svg
	cd BUILD/mcxtrace-mxrun && make install DESTDIR=$(CURDIR)/debian/mcxtrace-mxrun
	cd BUILD/mcxtrace-mxgui && make install DESTDIR=$(CURDIR)/debian/mcxtrace-mxgui
	cd BUILD/mcxtrace-mxdisplay-webgl && make install DESTDIR=$(CURDIR)/debian/mcxtrace-mxdisplay-webgl
	cd BUILD/mcxtrace-mxdisplay-pyqtgraph && make install DESTDIR=$(CURDIR)/debian/mcxtrace-mxdisplay-pyqtgraph
	cd BUILD/mcxtrace-clusterscripts && make install DESTDIR=$(CURDIR)/debian/mcxtrace-clusterscripts
	cd BUILD/mcxtrace-manuals && make install DESTDIR=$(CURDIR)/debian/mcxtrace-manuals
	cd BUILD/mcxtrace-mxdoc && make install DESTDIR=$(CURDIR)/debian/mcxtrace-mxdoc

	# Replace symlinks with the files they point to
	for i in $$(awk '/^Package:/ { print $$2 }' debian/control) ; do find debian/$$i -type l -print0 | xargs -r  -0 sed -i -e '' ; done

	debian/move-and-link-usr-share mcstas/usr/share/mccode/bin/mcstas

	# recode l1..u8 $(CURDIR)/debian/mcstas/usr/share/mccode/mcstas/$(MCCODE_VERSION)/share/general.c
	# recode l1..u8 $(CURDIR)/debian/mcstas/usr/share/mccode/mcstas/$(MCCODE_VERSION)/share/intersection.c
